diff --git a/sys/compat/cheriabi/cheriabi_caprevoke.c b/sys/compat/cheriabi/cheriabi_caprevoke.c
new file mode 100644
index 000000000000..29de2245e6d5
--- /dev/null
+++ b/sys/compat/cheriabi/cheriabi_caprevoke.c
@@ -0,0 +1,629 @@
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include "opt_compat.h"
+
+#define	EXPLICIT_USER_ACCESS
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/signal.h>
+#include <sys/user.h>
+
+#include <compat/cheriabi/cheriabi.h>
+#include <compat/cheriabi/cheriabi_util.h>
+#include <compat/cheriabi/cheriabi_proto.h>
+#include <compat/cheriabi/cheriabi_syscall.h>
+
+#include <sys/caprevoke.h>
+
+#ifdef CHERI_CAPREVOKE
+
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/proc.h>
+
+#include <vm/vm.h>
+#include <vm/vm_extern.h>
+#include <vm/vm_param.h>
+#include <vm/pmap.h>
+#include <vm/vm_map.h>
+
+#include <cheri/cheric.h>
+
+#include <sys/file.h>
+#include <sys/filedesc.h>
+#include <vm/vm_caprevoke.h>
+
+/*
+ * When revoking capabilities, we have to visit several kernel hoarders.
+ *
+ * XXX This gets exciting when these resources are shared.  For the moment,
+ * we consider only the case where these are in 1:1 correspondence with
+ * address spaces, but that's not going to be true in general (e.g., shared
+ * file descriptor tables) even today, nevermind when we start doing things
+ * like colocated processes.  Anyway, can we handwave away some of it and
+ * say that "enough" of the world must be stopped?
+ *
+ * Since some stashes allow aliasing (e.g. dup2() for filedescs), we must
+ * hold some locks for uncomfortably long.
+ */
+static void
+caprevoke_hoarders(struct proc *p, struct vm_caprevoke_cookie *crc)
+{
+	/* kqueue */
+	{
+		int fd;
+		struct filedesc *fdp = p->p_fd;
+		FILEDESC_SLOCK(fdp);
+		for (fd = 0; fd <= fdp->fd_lastfile; fd++) {
+			struct file * fp = fdp->fd_ofiles[fd].fde_file;
+			if ((fp != NULL) && (fp->f_type == DTYPE_KQUEUE)) {
+
+				/*
+				 * We ignore errors from this function; they
+				 * indicate either that the kq has yet to be
+				 * born or that it's dying, and in either
+				 * case, that should be fine.
+				 */
+				kqueue_caprevoke(fp, crc);
+			}
+		}
+		FILEDESC_SUNLOCK(fdp);
+	}
+
+	/* aio */
+	aio_caprevoke(p, crc);
+
+	/* timers */
+	ktimer_caprevoke(p, crc);
+}
+
+static int
+cheriabi_caprevoke_fini(struct thread *td, struct cheriabi_caprevoke_args *uap,
+			int res, struct caprevoke_stats *crst)
+{
+	int res2 = copyout(crst, uap->statout, sizeof (*crst));
+	if (res != 0)
+		return res;
+	return res2;
+}
+
+static void
+cheriabi_caprevoke_just(struct thread *td, struct vm_caprevoke_cookie *vmcrc,
+			struct caprevoke_stats *stats,
+			struct cheriabi_caprevoke_args *uap)
+{
+	/*
+	 * Unlocked access is fine; this is advisory and, when it is
+	 * relevant to userland, we expect that userland has already
+	 * arranged for the bitmasks to carry the state it wants and
+	 * wants to *now* wait for the clock to advance to be sure
+	 * that time has elapsed.
+	 *
+	 * XXX But on ALPHA, we might need to explicitly add a read
+	 * barrier, unless we've already done something that's
+	 * implied a suitable one on syscall entry, which seems
+	 * unlikely.
+	 */
+	stats->epoch_init =
+		vmcrc->map->vm_caprev_st >> CAPREVST_EPOCH_SHIFT;
+
+	if (uap->flags & CAPREVOKE_JUST_MY_REGS) {
+		caprevoke_td_frame(td, vmcrc);
+	}
+	if (uap->flags & CAPREVOKE_JUST_MY_STACK) {
+		vm_caprevoke_one(vmcrc, 0,
+			(vm_offset_t)(__cheri_fromcap void *)
+				(td->td_frame->csp));
+	}
+	if (uap->flags & CAPREVOKE_JUST_HOARDERS) {
+		caprevoke_hoarders(td->td_proc, vmcrc);
+	}
+
+	/* XXX unlocked read OK? */
+	stats->epoch_fini =
+		vmcrc->map->vm_caprev_st >> CAPREVST_EPOCH_SHIFT;
+}
+
+#define SET_ST(vp, e, st) \
+	(vp)->vm_caprev_st = (((e) << CAPREVST_EPOCH_SHIFT) | (st))
+
+int
+cheriabi_caprevoke(struct thread *td, struct cheriabi_caprevoke_args *uap)
+{
+	int res;
+	caprevoke_epoch epoch;
+	enum caprevoke_state entryst, myst;
+	struct caprevoke_info cri;
+	struct caprevoke_stats stat = { 0 };
+	struct vmspace *vm;
+	vm_map_t vmm;
+	struct vm_caprevoke_cookie vmcrc;
+
+	vm = vmspace_acquire_ref(td->td_proc);
+	res = vm_caprevoke_cookie_init(&vm->vm_map, &stat, &vmcrc);
+	if (res != KERN_SUCCESS) {
+		vmspace_free(vm);
+		return cheriabi_caprevoke_fini(td, uap, vm_mmap_to_errno(res),
+					       &stat);
+	}
+	if ((uap->flags & CAPREVOKE_JUST_MASK) != 0) {
+		cheriabi_caprevoke_just(td, &vmcrc, &stat, uap);
+		vm_caprevoke_cookie_rele(&vmcrc);
+		vmspace_free(vm);
+		return cheriabi_caprevoke_fini(td, uap, 0, &stat);
+	}
+	/* Engaging the full state machine; here we go! */
+
+	vmm = vmcrc.map;
+
+	/*
+	 * We need some value that's more or less "now", but we don't have
+	 * to be too picky about it.  This value is not reported to
+	 * userland, just used to guide the interlocking below.
+	 */
+	if ((uap->flags & CAPREVOKE_IGNORE_START) != 0) {
+		uap->start_epoch = vmm->vm_caprev_st >> CAPREVST_EPOCH_SHIFT;
+	}
+
+	/*
+	 * XXX We don't support late phases anyway, except as a placeholder,
+	 * so act like the user asked us not to do one.
+	 */
+	uap->flags |= CAPREVOKE_LAST_NO_LATE;
+
+	/* Serialize and figure out what we're supposed to do */
+	vm_map_lock(vmm);
+	{
+		static const int fast_out_flags = CAPREVOKE_NO_WAIT_OK
+						| CAPREVOKE_IGNORE_START
+						| CAPREVOKE_LAST_NO_EARLY;
+		int ires = 0;
+		caprevoke_epoch first_epoch;
+
+		epoch = vmm->vm_caprev_st >> CAPREVST_EPOCH_SHIFT;
+		first_epoch = epoch;
+
+		/*
+		 * Be optimistic about the outcome of any worker currently
+		 * in progress.  We cannot truly claim that all writes to
+		 * the revocation bitmap began prior to the epoch clock's
+		 * current value if that value is in the process of being
+		 * advanced by another thread: the writes may have happened
+		 * after that thread began its work.  Therefore, bump the
+		 * counter reported to userland appropriately.
+		 *
+		 * If the current epoch already clears the given
+		 * start_epoch, this may result in epoch_init > epoch_fini!
+		 *
+		 * Similarly, if the thread advancing the clock fails to do
+		 * so, we may find that our reported epoch_init is greater
+		 * than the epoch clock and so we may end up attempting to
+		 * advance only up to this report.  This is compensated for
+		 * below, when we wake up from sleep and notice that the
+		 * epoch has not advanced.
+		 */
+
+		switch(vmm->vm_caprev_st & CAPREVST_ST_MASK) {
+		case CAPREVST_INIT_PASS:
+			/*
+			 * A revoker intends to open, but not close, this
+			 * epoch.
+			 */
+			stat.epoch_init = epoch + 1;
+			break;
+		case CAPREVST_LAST_PASS:
+			/*
+			 * A revoker intends to close an epoch, which may
+			 * be the one now open or the next one.  In either
+			 * case, the resulting epoch is closed and advanced
+			 * from its present value.
+			 */
+			stat.epoch_init = (epoch & ~1) + 2;
+			break;
+		case CAPREVST_NONE:
+		case CAPREVST_INIT_DONE:
+			/*
+			 * There is no active worker; the epoch clock is
+			 * a true reflection of the time.
+			 */
+			stat.epoch_init = epoch;
+			break;
+		}
+
+		if ((uap->flags & (fast_out_flags|CAPREVOKE_LAST_PASS))
+		    == fast_out_flags) {
+			/* Apparently they really just wanted the time. */
+			goto fast_out;
+		}
+
+reentry:
+		if (caprevoke_epoch_clears(epoch, uap->start_epoch)) {
+			/*
+			 * An entire epoch has come and gone since the
+			 * starting point of this request.  It is safe to
+			 * return to userland with the request satiated.
+			 *
+			 * In case we queued, tho', go ahead and wake up the
+			 * next would-be revoker first.
+			 */
+fast_out:
+			vm_map_unlock(vmm);
+			cv_signal(&vmm->vm_caprev_cv);
+			vm_caprevoke_cookie_rele(&vmcrc);
+			vmspace_free(vm);
+			stat.epoch_fini = epoch;
+			return cheriabi_caprevoke_fini(td, uap, ires, &stat);
+		}
+
+		/*
+		 * OK, the initial epoch clock isn't in the past.  Let's see
+		 * what state we're in and what we can accomplish.
+		 */
+		entryst = vmm->vm_caprev_st & CAPREVST_ST_MASK;
+		switch(entryst) {
+		case CAPREVST_NONE:
+			/*
+			 * Begin, non-incremental; advance clock.  We might
+			 * also be ending the epoch at the same time.
+			 */
+			if (uap->flags & CAPREVOKE_LAST_PASS) {
+				myst = CAPREVST_LAST_PASS;
+			} else {
+				myst = CAPREVST_INIT_PASS;
+			}
+			KASSERT((epoch & 1) == 0, ("Odd epoch NONE"));
+			break;
+		case CAPREVST_INIT_DONE:
+			/* We could either be finishing up or doing another pass */
+			if (uap->flags & CAPREVOKE_LAST_PASS) {
+				myst = CAPREVST_LAST_PASS;
+			} else {
+				myst = CAPREVST_INIT_PASS;
+			}
+			KASSERT((epoch & 1) == 1, ("Even epoch INIT"));
+			break;
+		case CAPREVST_LAST_PASS:
+			if ((uap->flags & CAPREVOKE_ONLY_IF_OPEN) != 0) {
+				goto fast_out;
+			}
+			/* FALLTHROUGH */
+		case CAPREVST_INIT_PASS:
+			if ((uap->flags & CAPREVOKE_NO_WAIT_OK) != 0) {
+				goto fast_out;
+			}
+
+			/* There is another revoker in progress.  Wait. */
+			KASSERT(vmm->system_map == 0, ("System map?"));
+			ires = cv_wait_sig(&vmm->vm_caprev_cv, &vmm->lock);
+			if (ires != 0) {
+				goto fast_out;
+			}
+
+			epoch = vmm->vm_caprev_st
+				>> CAPREVST_EPOCH_SHIFT;
+			if (epoch == first_epoch) {
+				stat.epoch_init = epoch;
+			}
+			goto reentry;
+		}
+
+		KASSERT((entryst == CAPREVST_NONE)
+			 || (entryst == CAPREVST_INIT_DONE),
+			("Beginning revocation with bad entry state"));
+		KASSERT((myst == CAPREVST_INIT_PASS)
+			 || (myst == CAPREVST_LAST_PASS),
+			("Beginning revocation with bad current state"));
+
+		if (((uap->flags & CAPREVOKE_ONLY_IF_OPEN) != 0)
+		    && ((epoch & 1) == 0)) {
+			/*
+			 * If we're requesting work only if an epoch is open
+			 * and one isn't, then there's only one thing to do!
+			 */
+			goto fast_out;
+		}
+
+		/*
+		 * Don't bump the epoch count here, just the state!  Wait
+		 * until we're certain it's actually open, which we can only
+		 * do below.
+		 */
+		SET_ST(vmm, epoch, myst);
+	}
+	vm_map_unlock(vmm);
+
+	/*
+	 * I am the revoker; expose an incremented epoch to userland
+	 * for its enqueue side.  Use a store fence to ensure that this
+	 * is visible before any of our subsequent loads (we can't use
+	 * vm map lock to do this, because copyout might need the map).
+	 */
+	if ((entryst == CAPREVST_NONE) && (myst == CAPREVST_LAST_PASS)) {
+		cri.epoch_enqueue = epoch + 2;
+	} else {
+		cri.epoch_enqueue = epoch + 1;
+	}
+	cri.epoch_dequeue = epoch;
+	vm_caprevoke_publish(&vmcrc, &cri);
+	wmb();
+
+	/* Walk the VM unless told not to */
+	if ((uap->flags & CAPREVOKE_LAST_NO_EARLY) == 0) {
+		res = vm_caprevoke(&vmcrc,
+			/* Userspace can ask us to avoid an IPI here */
+		   (((uap->flags & CAPREVOKE_EARLY_SYNC) != 0)
+			? VM_CAPREVOKE_PMAP_SYNC : 0)
+			/* If not first pass, only recently capdirty pages */
+		   | ((entryst == CAPREVST_INIT_DONE)
+			? VM_CAPREVOKE_INCREMENTAL : 0));
+
+		if (res == KERN_SUCCESS) {
+			/*
+			 * That worked; the epoch is certainly open; when we
+			 * set the state below, it's fine to advance the
+			 * clock rather than revert it, even if something
+			 * else goes wrong.
+			 *
+			 * Note that this is a purely local change even so;
+			 * threads interlocking against us will not see it
+			 * until we next publish the state below.
+			 */
+			if (entryst == CAPREVST_NONE) {
+				epoch++;
+				entryst = CAPREVST_INIT_DONE;
+			}
+		} else {
+			goto skip_last_pass;
+		}
+	}
+
+	/*
+	 * If we are beginning the last pass, single-thread the world and
+	 * expunge state that we want to ensure does not become visible
+	 * during the body of the last pass.
+	 */
+	if (myst == CAPREVST_LAST_PASS) {
+		struct thread *ptd;
+
+		PROC_LOCK(td->td_proc);
+		if ((td->td_proc->p_flag & P_HADTHREADS) != 0) {
+			if (thread_single(td->td_proc, SINGLE_BOUNDARY)) {
+				PROC_UNLOCK(td->td_proc);
+
+				vm_map_lock(vmm);
+				SET_ST(vmm, epoch, entryst);
+				vm_map_unlock(vmm);
+
+				/* XXX Don't signal other would-be revokers? */
+
+				vm_caprevoke_cookie_rele(&vmcrc);
+				vmspace_free(vm);
+
+				/* XXX Don't copy out the stat structure? */
+
+				return ERESTART;
+			}
+		}
+
+		/* Register file */
+		FOREACH_THREAD_IN_PROC(td->td_proc, ptd) {
+			caprevoke_td_frame(ptd, &vmcrc);
+			sigaltstack_caprevoke(td, &vmcrc);
+		}
+		PROC_UNLOCK(td->td_proc);
+
+		/* Kernel hoarders */
+		caprevoke_hoarders(td->td_proc, &vmcrc);
+
+		/*
+		 * The world is stopped; do another pass through the VM.
+		 *
+		 * This pass can be incremental if we had previously done an
+		 * init pass, either just now or earlier.  In either case,
+		 * we'll have entryst == CAPREVST_INIT_DONE; there's no need
+		 * to look at CAPREVOKE_LAST_NO_EARLY.
+		 */
+		res = vm_caprevoke(&vmcrc,
+			((entryst == CAPREVST_INIT_DONE)
+				? VM_CAPREVOKE_INCREMENTAL : 0)
+			| VM_CAPREVOKE_LAST_INIT
+			| VM_CAPREVOKE_PMAP_SYNC
+			| (((uap->flags & CAPREVOKE_LAST_NO_LATE) != 0)
+				? VM_CAPREVOKE_LAST_FINI : 0));
+
+		PROC_LOCK(td->td_proc);
+		if ((td->td_proc->p_flag & P_HADTHREADS) != 0) {
+			/* Un-single-thread the world */
+			thread_single_end(td->td_proc, SINGLE_BOUNDARY);
+		}
+
+		if (res != KERN_SUCCESS) {
+			PROC_UNLOCK(td->td_proc);
+
+			vm_map_lock(vmm);
+			SET_ST(vmm, epoch, entryst);
+			vm_map_unlock(vmm);
+
+			cv_signal(&vmm->vm_caprev_cv);
+
+			vm_caprevoke_cookie_rele(&vmcrc);
+			vmspace_free(vm);
+
+			stat.epoch_fini = epoch;
+			return cheriabi_caprevoke_fini(td, uap, 0, &stat);
+		}
+		PROC_UNLOCK(td->td_proc);
+
+		if (entryst == CAPREVST_NONE) {
+			/* That counts as our initial pass */
+			epoch++;
+			entryst = CAPREVST_INIT_DONE;
+		}
+
+		if ((uap->flags & CAPREVOKE_LAST_NO_LATE) == 0) {
+			/*
+			 * Walk the VM again, now with the world running;
+			 * as we must have done a pass before here, this is
+			 * certain to be an incremental pass.
+			 */
+			res = vm_caprevoke(&vmcrc,
+				VM_CAPREVOKE_INCREMENTAL
+				| VM_CAPREVOKE_LAST_FINI);
+		}
+	}
+
+skip_last_pass:
+	/* OK, that's that.  Where do we stand now? */
+	{
+		if ((res == KERN_SUCCESS) && (myst == CAPREVST_LAST_PASS)) {
+			/* Signal the end of this revocation epoch */
+			epoch++;
+			cri.epoch_dequeue = epoch;
+			vm_caprevoke_publish(&vmcrc, &cri);
+			vm_map_lock(vmm);
+			SET_ST(vmm, epoch, CAPREVST_NONE);
+			vm_map_unlock(vmm);
+		} else {
+			/*
+			 * Put the state back how we found it, modulo
+			 * having perhaps finished the first pass.
+			 */
+			cri.epoch_dequeue = epoch;
+			vm_caprevoke_publish(&vmcrc, &cri);
+			vm_map_lock(vmm);
+			SET_ST(vmm, epoch, entryst);
+			vm_map_unlock(vmm);
+		}
+	}
+
+	/* Broadcast here: some sleepers may be able to take the fast out */
+	cv_broadcast(&vmm->vm_caprev_cv);
+
+	vm_caprevoke_cookie_rele(&vmcrc);
+	vmspace_free(vm);
+
+	/*
+	 * Return the epoch as it was at the end of the run above,
+	 * not necessarily as it is now.  This value is useful only
+	 * for retroactive comparisons, i.e., to answer if
+	 * particular epochs are in the past.
+	 */
+	stat.epoch_fini = epoch;
+
+	return cheriabi_caprevoke_fini(td, uap, 0, &stat);
+}
+
+int
+cheriabi_caprevoke_shadow(struct thread *td,
+			    struct cheriabi_caprevoke_shadow_args *uap)
+{
+	int arena_perms, error;
+	void * __capability cres;
+	vm_offset_t base, size;
+	int sel = uap->flags & CAPREVOKE_SHADOW_SPACE_MASK;
+
+	if (!SV_CURPROC_FLAG(SV_CHERI))
+		return ENOSYS;
+
+	switch (sel) {
+	case CAPREVOKE_SHADOW_NOVMMAP:
+
+		if (cheri_gettag(uap->arena) == 0)
+			return EINVAL;
+
+		arena_perms = cheri_getperm(uap->arena);
+
+		if ((arena_perms & CHERI_PERM_CHERIABI_VMMAP) == 0)
+			return EPERM;
+
+		base = cheri_getbase(uap->arena);
+		size = cheri_getlen(uap->arena);
+
+		cres = vm_caprevoke_shadow_cap(sel, base, size, arena_perms);
+
+		break;
+
+	case CAPREVOKE_SHADOW_OTYPE: {
+		int reqperms;
+
+		if (cheri_gettag(uap->arena) == 0)
+			return EINVAL;
+
+		/* XXX Require all of VMMAP, SEAL, and UNSEAL permissions? */
+		reqperms = CHERI_PERM_SEAL | CHERI_PERM_UNSEAL
+			     | CHERI_PERM_CHERIABI_VMMAP;
+		arena_perms = cheri_getperm(uap->arena);
+		if ((arena_perms & reqperms) != reqperms)
+			return EPERM;
+
+		base = cheri_getbase(uap->arena);
+		size = cheri_getlen(uap->arena);
+
+		cres = vm_caprevoke_shadow_cap(sel, base, size, 0);
+
+		}
+		break;
+
+	case CAPREVOKE_SHADOW_INFO_STRUCT: {
+		/* Anyone's allowed to ask, I guess; ->arena ignored. */
+		cres = vm_caprevoke_shadow_cap(sel, 0, 0, 0);
+
+		break;
+	}
+	default:
+		return EINVAL;
+	}
+
+	if (cheri_gettag(cres))
+		error = copyoutcap(&cres, uap->shadow, sizeof(cres));
+	else
+		error = (__cheri_addr uintptr_t)cres;
+
+	return error;
+}
+
+extern void * __capability caprev_shadow_cap;
+int
+cheriabi_caprevoke_entire_shadow_cap(struct thread *td,
+			    struct cheriabi_caprevoke_entire_shadow_cap_args *uap)
+{
+	return copyoutcap(&caprev_shadow_cap, uap->shadow, sizeof(caprev_shadow_cap));
+}
+
+#else /* CHERI_CAPREVOKE */
+
+int
+cheriabi_caprevoke(struct thread *td, struct cheriabi_caprevoke_args *uap)
+{
+	struct caprevoke_stats stat = { 0 };
+
+	copyout(&stat, uap->statout, sizeof (stat));
+
+	return ENOSYS;
+}
+
+int
+cheriabi_caprevoke_shadow(struct thread *td,
+			    struct cheriabi_caprevoke_shadow_args *uap)
+{
+	void * __capability cres = NULL;
+
+	copyoutcap(&cres, uap->shadow, sizeof(cres));
+
+	return ENOSYS;
+}
+
+int
+cheriabi_caprevoke_entire_shadow_cap(struct thread *td,
+			    struct cheriabi_caprevoke_entire_shadow_cap_args *uap)
+{
+	void * __capability cres = NULL;
+
+	copyoutcap(&cres, uap->shadow, sizeof(cres));
+
+	return ENOSYS;
+}
+
+#endif /* CHERI_CAPREVOKE */
diff --git a/sys/compat/cheriabi/cheriabi_proto.h b/sys/compat/cheriabi/cheriabi_proto.h
index b23eedc8c1d2..f01777ba5500 100644
--- a/sys/compat/cheriabi/cheriabi_proto.h
+++ b/sys/compat/cheriabi/cheriabi_proto.h
@@ -514,6 +514,19 @@ struct cheriabi_kbounce_args {
 	char len_l_[PADL_(size_t)]; size_t len; char len_r_[PADR_(size_t)];
 	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
 };
+struct cheriabi_caprevoke_shadow_args {
+	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
+	char arena_l_[PADL_(void * __capability)]; void * __capability arena; char arena_r_[PADR_(void * __capability)];
+	char shadow_l_[PADL_(void * __capability)]; void * __capability shadow; char shadow_r_[PADR_(void * __capability)];
+};
+struct cheriabi_caprevoke_args {
+	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
+	char start_epoch_l_[PADL_(uint64_t)]; uint64_t start_epoch; char start_epoch_r_[PADR_(uint64_t)];
+	char statout_l_[PADL_(struct caprevoke_stats * __capability)]; struct caprevoke_stats * __capability statout; char statout_r_[PADR_(struct caprevoke_stats * __capability)];
+};
+struct cheriabi_caprevoke_entire_shadow_cap_args {
+	char shadow_l_[PADL_(void * __capability)]; void * __capability shadow; char shadow_r_[PADR_(void * __capability)];
+};
 struct cheriabi_lchmod_args {
 	char path_l_[PADL_(const char * __capability)]; const char * __capability path; char path_r_[PADR_(const char * __capability)];
 	char mode_l_[PADL_(mode_t)]; mode_t mode; char mode_r_[PADR_(mode_t)];
@@ -1567,6 +1580,9 @@ int	cheriabi_aio_read(struct thread *, struct cheriabi_aio_read_args *);
 int	cheriabi_aio_write(struct thread *, struct cheriabi_aio_write_args *);
 int	cheriabi_lio_listio(struct thread *, struct cheriabi_lio_listio_args *);
 int	cheriabi_kbounce(struct thread *, struct cheriabi_kbounce_args *);
+int	cheriabi_caprevoke_shadow(struct thread *, struct cheriabi_caprevoke_shadow_args *);
+int	cheriabi_caprevoke(struct thread *, struct cheriabi_caprevoke_args *);
+int	cheriabi_caprevoke_entire_shadow_cap(struct thread *, struct cheriabi_caprevoke_entire_shadow_cap_args *);
 int	cheriabi_lchmod(struct thread *, struct cheriabi_lchmod_args *);
 int	cheriabi_lutimes(struct thread *, struct cheriabi_lutimes_args *);
 int	cheriabi_preadv(struct thread *, struct cheriabi_preadv_args *);
@@ -1902,6 +1918,9 @@ int	cheriabi_shm_rename(struct thread *, struct cheriabi_shm_rename_args *);
 #define	CHERIABI_SYS_AUE_cheriabi_aio_write	AUE_AIO_WRITE
 #define	CHERIABI_SYS_AUE_cheriabi_lio_listio	AUE_LIO_LISTIO
 #define	CHERIABI_SYS_AUE_cheriabi_kbounce	AUE_NULL
+#define	CHERIABI_SYS_AUE_cheriabi_caprevoke_shadow	AUE_NULL
+#define	CHERIABI_SYS_AUE_cheriabi_caprevoke	AUE_NULL
+#define	CHERIABI_SYS_AUE_cheriabi_caprevoke_entire_shadow_cap	AUE_NULL
 #define	CHERIABI_SYS_AUE_cheriabi_lchmod	AUE_LCHMOD
 #define	CHERIABI_SYS_AUE_cheriabi_lutimes	AUE_LUTIMES
 #define	CHERIABI_SYS_AUE_cheriabi_preadv	AUE_PREADV
diff --git a/sys/compat/cheriabi/cheriabi_sysargmap.h b/sys/compat/cheriabi/cheriabi_sysargmap.h
index 9f3b72f7a916..3445d98b04e3 100644
--- a/sys/compat/cheriabi/cheriabi_sysargmap.h
+++ b/sys/compat/cheriabi/cheriabi_sysargmap.h
@@ -145,6 +145,9 @@ int cheriabi_sysargmask[] = {
  [CHERIABI_SYS_cheriabi_aio_write] = (0x0 | 0x1),
  [CHERIABI_SYS_cheriabi_lio_listio] = (0x0 | 0x2 | 0x8),
  [CHERIABI_SYS_cheriabi_kbounce] = (0x0 | 0x1 | 0x2),
+ [CHERIABI_SYS_cheriabi_caprevoke_shadow] = (0x0 | 0x2 | 0x4),
+ [CHERIABI_SYS_cheriabi_caprevoke] = (0x0 | 0x4),
+ [CHERIABI_SYS_cheriabi_caprevoke_entire_shadow_cap] = (0x0 | 0x1),
  [CHERIABI_SYS_cheriabi_lchmod] = (0x0 | 0x1),
  [CHERIABI_SYS_cheriabi_lutimes] = (0x0 | 0x1 | 0x2),
  [CHERIABI_SYS_cheriabi_preadv] = (0x0 | 0x2),
diff --git a/sys/compat/cheriabi/cheriabi_syscall.h b/sys/compat/cheriabi/cheriabi_syscall.h
index 87b8a03b82d5..2531cb2216c2 100644
--- a/sys/compat/cheriabi/cheriabi_syscall.h
+++ b/sys/compat/cheriabi/cheriabi_syscall.h
@@ -235,6 +235,9 @@
 #define	CHERIABI_SYS_cheriabi_aio_write	256
 #define	CHERIABI_SYS_cheriabi_lio_listio	257
 #define	CHERIABI_SYS_cheriabi_kbounce	258
+#define	CHERIABI_SYS_cheriabi_caprevoke_shadow	259
+#define	CHERIABI_SYS_cheriabi_caprevoke	260
+#define	CHERIABI_SYS_cheriabi_caprevoke_entire_shadow_cap	261
 				/* 272 is obsolete freebsd11_getdents */
 #define	CHERIABI_SYS_cheriabi_lchmod	274
 				/* 275 is obsolete netbsd_lchown */
diff --git a/sys/compat/cheriabi/cheriabi_syscall.mk b/sys/compat/cheriabi/cheriabi_syscall.mk
index 38358061d3f6..6b3705f74830 100644
--- a/sys/compat/cheriabi/cheriabi_syscall.mk
+++ b/sys/compat/cheriabi/cheriabi_syscall.mk
@@ -153,6 +153,9 @@ MIASM =  \
 	cheriabi_aio_write.o \
 	cheriabi_lio_listio.o \
 	cheriabi_kbounce.o \
+	cheriabi_caprevoke_shadow.o \
+	cheriabi_caprevoke.o \
+	cheriabi_caprevoke_entire_shadow_cap.o \
 	cheriabi_lchmod.o \
 	cheriabi_lutimes.o \
 	cheriabi_preadv.o \
diff --git a/sys/compat/cheriabi/cheriabi_syscalls.c b/sys/compat/cheriabi/cheriabi_syscalls.c
index bf14725468cc..6c650d9ebe54 100644
--- a/sys/compat/cheriabi/cheriabi_syscalls.c
+++ b/sys/compat/cheriabi/cheriabi_syscalls.c
@@ -265,9 +265,9 @@ const char *cheriabi_syscallnames[] = {
 	"cheriabi_aio_write",			/* 256 = cheriabi_aio_write */
 	"cheriabi_lio_listio",			/* 257 = cheriabi_lio_listio */
 	"cheriabi_kbounce",			/* 258 = cheriabi_kbounce */
-	"#259",			/* 259 = nosys */
-	"#260",			/* 260 = nosys */
-	"#261",			/* 261 = nosys */
+	"cheriabi_caprevoke_shadow",			/* 259 = cheriabi_caprevoke_shadow */
+	"cheriabi_caprevoke",			/* 260 = cheriabi_caprevoke */
+	"cheriabi_caprevoke_entire_shadow_cap",			/* 261 = cheriabi_caprevoke_entire_shadow_cap */
 	"#262",			/* 262 = nosys */
 	"#263",			/* 263 = nosys */
 	"#264",			/* 264 = nosys */
diff --git a/sys/compat/cheriabi/cheriabi_sysent.c b/sys/compat/cheriabi/cheriabi_sysent.c
index 5d13f4e8c126..fc230f9ac621 100644
--- a/sys/compat/cheriabi/cheriabi_sysent.c
+++ b/sys/compat/cheriabi/cheriabi_sysent.c
@@ -273,9 +273,9 @@ struct sysent cheriabi_sysent[] = {
 	{ AS(cheriabi_aio_write_args), (sy_call_t *)cheriabi_aio_write, AUE_AIO_WRITE, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 256 = cheriabi_aio_write */
 	{ AS(cheriabi_lio_listio_args), (sy_call_t *)cheriabi_lio_listio, AUE_LIO_LISTIO, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 257 = cheriabi_lio_listio */
 	{ AS(cheriabi_kbounce_args), (sy_call_t *)cheriabi_kbounce, AUE_NULL, NULL, 0, 0, 0, SY_THR_STATIC },	/* 258 = cheriabi_kbounce */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 259 = nosys */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 260 = nosys */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 261 = nosys */
+	{ AS(cheriabi_caprevoke_shadow_args), (sy_call_t *)cheriabi_caprevoke_shadow, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 259 = cheriabi_caprevoke_shadow */
+	{ AS(cheriabi_caprevoke_args), (sy_call_t *)cheriabi_caprevoke, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 260 = cheriabi_caprevoke */
+	{ AS(cheriabi_caprevoke_entire_shadow_cap_args), (sy_call_t *)cheriabi_caprevoke_entire_shadow_cap, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 261 = cheriabi_caprevoke_entire_shadow_cap */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 262 = nosys */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 263 = nosys */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 264 = nosys */
diff --git a/sys/compat/cheriabi/cheriabi_sysstubs.h b/sys/compat/cheriabi/cheriabi_sysstubs.h
index 310f4b654e8f..64d0f415da97 100644
--- a/sys/compat/cheriabi/cheriabi_sysstubs.h
+++ b/sys/compat/cheriabi/cheriabi_sysstubs.h
@@ -15,12 +15,11 @@
 #include <sys/wait.h>
 
 #include <compat/cheriabi/cheriabi_signal.h>
-struct __ucontext;
-struct __wrusage;
 struct acl;
 struct aiocb;
-struct auditinfo_addr;
 struct auditinfo;
+struct auditinfo_addr;
+struct caprevoke_stats;
 struct ffclock_estimate;
 struct fhandle;
 struct freebsd11_stat;
@@ -30,15 +29,15 @@ struct iovec;
 struct itimerspec;
 struct itimerval;
 struct jail;
-struct kevent_freebsd11;
 struct kevent;
+struct kevent_freebsd11;
 struct kld_file_stat;
 struct mac;
 struct module_stat;
 struct mq_attr;
 struct msghdr;
-struct msqid_ds_old;
 struct msqid_ds;
+struct msqid_ds_old;
 struct nstat;
 struct ntptimeval;
 struct oaiocb;
@@ -57,8 +56,8 @@ struct sched_param;
 struct sctp_sndrcvinfo;
 struct sembuf;
 struct sf_hdtr;
-struct shmid_ds_old;
 struct shmid_ds;
+struct shmid_ds_old;
 struct sigaction;
 struct sigaltstack;
 struct sigevent;
@@ -73,10 +72,12 @@ struct timespec;
 struct timeval;
 struct timex;
 struct timezone;
+struct __ucontext;
 struct utsname;
 struct uuid;
-union semun_old;
+struct __wrusage;
 union semun;
+union semun_old;
 SYS_STUB(2, int, fork,
     /* _protoargs */ (void),
     /* _protoargs_chk */ (int *retp , int * __capability stub_errno),
@@ -1518,6 +1519,36 @@ SYS_STUB(258, int, kbounce,
     /* _localcheck */ {if (!(cheri_getperm(src) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((int)-1);} if (!(cheri_getperm(dst) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((int)-1);} }
 )
 
+SYS_STUB(259, int, caprevoke_shadow,
+    /* _protoargs */ (int flags, void *  arena, void *  shadow),
+    /* _protoargs_chk */ (int *retp , int * __capability stub_errno, int flags, void * __capability   arena, void * __capability   shadow),
+    /* _protoargs_err */ (int * __capability stub_errno, int flags, void * __capability   arena, void * __capability   shadow),
+    /* _callargs */ (flags, (__cheri_fromcap void * )arena, (__cheri_fromcap void * )shadow),
+    /* _callargs_chk */ (&ret, stub_errno, flags, arena, shadow),
+    /* _callargs_err */ (&errno, flags, (void * )arena, (void * )shadow),
+    /* _localcheck */ {if (!(cheri_getperm(arena) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((int)-1);} if (!(cheri_getperm(shadow) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((int)-1);} }
+)
+
+SYS_STUB(260, void*, caprevoke,
+    /* _protoargs */ (int flags, uint64_t start_epoch, struct caprevoke_stats *  statout),
+    /* _protoargs_chk */ (void* *retp , int * __capability stub_errno, int flags, uint64_t start_epoch, struct caprevoke_stats * __capability   statout),
+    /* _protoargs_err */ (int * __capability stub_errno, int flags, uint64_t start_epoch, struct caprevoke_stats * __capability   statout),
+    /* _callargs */ (flags, start_epoch, (__cheri_fromcap struct caprevoke_stats * )statout),
+    /* _callargs_chk */ (&ret, stub_errno, flags, start_epoch, statout),
+    /* _callargs_err */ (&errno, flags, start_epoch, (struct caprevoke_stats * )statout),
+    /* _localcheck */ {if (!(cheri_getperm(statout) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((void*)-1);} }
+)
+
+SYS_STUB(261, void*, caprevoke_entire_shadow_cap,
+    /* _protoargs */ (void *  shadow),
+    /* _protoargs_chk */ (void* *retp , int * __capability stub_errno, void * __capability   shadow),
+    /* _protoargs_err */ (int * __capability stub_errno, void * __capability   shadow),
+    /* _callargs */ ((__cheri_fromcap void * )shadow),
+    /* _callargs_chk */ (&ret, stub_errno, shadow),
+    /* _callargs_err */ (&errno, (void * )shadow),
+    /* _localcheck */ {if (!(cheri_getperm(shadow) & CHERI_PERM_GLOBAL)) {errno = EPROT; return ((void*)-1);} }
+)
+
 SYS_STUB(274, int, lchmod,
     /* _protoargs */ (const char *  path, mode_t mode),
     /* _protoargs_chk */ (int *retp , int * __capability stub_errno, const char * __capability   path, mode_t mode),
diff --git a/sys/compat/cheriabi/cheriabi_systrace_args.c b/sys/compat/cheriabi/cheriabi_systrace_args.c
index 9689122bd3c1..3ba1214336c3 100644
--- a/sys/compat/cheriabi/cheriabi_systrace_args.c
+++ b/sys/compat/cheriabi/cheriabi_systrace_args.c
@@ -1276,6 +1276,31 @@ systrace_args(int sysnum, void *params, uint64_t *uarg, int *n_args)
 		*n_args = 4;
 		break;
 	}
+	/* cheriabi_caprevoke_shadow */
+	case 259: {
+		struct cheriabi_caprevoke_shadow_args *p = params;
+		iarg[0] = p->flags; /* int */
+		uarg[1] = (__cheri_addr intptr_t) p->arena; /* void * __capability */
+		uarg[2] = (__cheri_addr intptr_t) p->shadow; /* void * __capability */
+		*n_args = 3;
+		break;
+	}
+	/* cheriabi_caprevoke */
+	case 260: {
+		struct cheriabi_caprevoke_args *p = params;
+		iarg[0] = p->flags; /* int */
+		uarg[1] = p->start_epoch; /* uint64_t */
+		uarg[2] = (__cheri_addr intptr_t) p->statout; /* struct caprevoke_stats * __capability */
+		*n_args = 3;
+		break;
+	}
+	/* cheriabi_caprevoke_entire_shadow_cap */
+	case 261: {
+		struct cheriabi_caprevoke_entire_shadow_cap_args *p = params;
+		uarg[0] = (__cheri_addr intptr_t) p->shadow; /* void * __capability */
+		*n_args = 1;
+		break;
+	}
 	/* cheriabi_lchmod */
 	case 274: {
 		struct cheriabi_lchmod_args *p = params;
@@ -5312,6 +5337,48 @@ systrace_entry_setargdesc(int sysnum, int ndx, char *desc, size_t descsz)
 			break;
 		};
 		break;
+	/* cheriabi_caprevoke_shadow */
+	case 259:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "userland void * __capability";
+			break;
+		case 2:
+			p = "userland void * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cheriabi_caprevoke */
+	case 260:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "uint64_t";
+			break;
+		case 2:
+			p = "userland struct caprevoke_stats * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cheriabi_caprevoke_entire_shadow_cap */
+	case 261:
+		switch(ndx) {
+		case 0:
+			p = "userland void * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
 	/* cheriabi_lchmod */
 	case 274:
 		switch(ndx) {
@@ -9566,6 +9633,21 @@ systrace_return_setargdesc(int sysnum, int ndx, char *desc, size_t descsz)
 		if (ndx == 0 || ndx == 1)
 			p = "int";
 		break;
+	/* cheriabi_caprevoke_shadow */
+	case 259:
+		if (ndx == 0 || ndx == 1)
+			p = "int";
+		break;
+	/* cheriabi_caprevoke */
+	case 260:
+		if (ndx == 0 || ndx == 1)
+			p = "void *";
+		break;
+	/* cheriabi_caprevoke_entire_shadow_cap */
+	case 261:
+		if (ndx == 0 || ndx == 1)
+			p = "void *";
+		break;
 	/* cheriabi_lchmod */
 	case 274:
 		if (ndx == 0 || ndx == 1)
